﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Threading;

namespace TPL_NET
{
    class Program
    {
        private static void msg(string komunikat)
        {
            Console.WriteLine(komunikat);            
        }

        static void Main(string[] args)
        {
            SpinWait sw = new SpinWait();
            int ileZadan = 10;

            Action<object> a = async (object o) =>
            {
                EventWaitHandle ewh = o as EventWaitHandle;
                string taskId = Task.CurrentId.HasValue ? Task.CurrentId.Value.ToString() : "UI";
                msg("Start zadania nr " + taskId.ToString());

                Task.Delay(1000).Wait();
                //await Task.Delay(1000);
                //for (int i = 0; i < 10000; ++i) sw.SpinOnce();

                msg("Koniec zadania nr " + taskId.ToString());
                ewh.Set();
            };

            List<Task> listaZadan = new List<Task>(ileZadan);
            List<EventWaitHandle> listaEWH = new List<EventWaitHandle>(ileZadan);
            for (int i = 0; i < ileZadan; ++i)
            {
                EventWaitHandle ewh = new EventWaitHandle(false, EventResetMode.ManualReset);
                listaEWH.Add(ewh);
                listaZadan.Add(new Task(a, ewh));
            }
            msg("Zadania utworzone");
            foreach (Task t in listaZadan) t.Start();
            msg("Zadania wysłane do puli wątków");
            foreach (Task t in listaZadan) t.Wait();
            //foreach (EventWaitHandle ewh in listaEWH) ewh.WaitOne();
            msg("Zadania zakończone");

            msg("KONIEC");
        }
    }
}
